﻿Structure winampGeneralPurposePlugin
  version.l; As INTEGER        'enthält die Version der Plugin-Struktur
  *description; As ANY PTR    'enthält den Pointer auf den Namen des Plugins
  *init       ; As ANY PTR           'enthält den Pointer auf die Funktion "finit()"
  *config     ; As ANY PTR         'enthält den Pointer auf die Sub "fconfig"
  *quit       ; As ANY PTR           'enthält den Pointer auf die Sub "fquit"
  hwndParent.l; As HWND        'enthält das Handle des Winamp-Hauptfensters. Wird von Winamp gesetzt
  hDllInstance.l; As HINSTANCE 'enthält das Instanzhandle der Plugin-dll. Wird von Winamp gesetzt
EndStructure

Global plugin.winampGeneralPurposePlugin
Global wcolor=RGB(0,127,0)

Procedure WinCallback(hWnd, uMsg, WParam, LParam) 
  Select uMsg
    Case #WM_LBUTTONDOWN
      SendMessage_(WindowID(1), #WM_NCLBUTTONDOWN, #HTCAPTION, 0)
      Case #WM_TIMER
        If WParam = 100
          hdc = StartDrawing(WindowOutput(1))
          If hdc
            ;Box(0, 0, width, height, wcolor);#White)
            DrawingMode(#PB_2DDrawing_Transparent)
            SelectObject_(hdc, GetStockObject_(#SYSTEM_FONT))
            wah.l=FindWindow_("Winamp v1.x",0);wawin();FindWindow_(@"Winamp v1.x",0)
            If wah
              tl.l=SendMessage_(wah,#WM_GETTEXTLENGTH,0,0)
              If tl
                *m=AllocateMemory(tl*2+4)
                SendMessage_(wah,#WM_GETTEXT,tl+1,*m)
                s$=PeekS(*m)
                FreeMemory(*m)
                s$=ReplaceString(s$," - Winamp","")
              EndIf
            Else
              s$="winamp not found"
            EndIf
            width=TextWidth(s$)
            height=TextHeight(s$)
            GetWindowRect_(GetDesktopWindow_(),r1.rect)
            xx=WindowX(1)
;            If GetGadgetState(#npc)
              xx=(r1\right-width)/2
;            EndIf
            ResizeWindow(1, xx, WindowY(1), width, height)
            ;DrawText(0,0,s$,nptc)
            ResizeGadget(0,GadgetX(0),GadgetY(0), width, height)
            SetGadgetText(0,s$)
            StopDrawing()
            StickyWindow(1, #True)
          EndIf
        EndIf;If WParam = 100
 EndSelect
ProcedureReturn #PB_ProcessPureBasicEvents 
EndProcedure 

Procedure  finit()
  If OpenWindow(0, 0, 0, 50, 50, "HiddenWindow", #PB_Window_Invisible)
  If OpenWindow(1, 0, 0, 200, 66, "My Message", #PB_Window_BorderLess, WindowID(0)); | #PB_Window_ScreenCentered);, WindowID(0))
    
    SetWindowColor(1, wcolor);#Magenta)
    SetWindowLong_(WindowID(1), #GWL_EXSTYLE, #WS_EX_LAYERED | #WS_EX_TOPMOST)
    SetLayeredWindowAttributes_(WindowID(1), wcolor, 0, #LWA_COLORKEY)
    StickyWindow(1, #True)
    ;LoadFont(0, "Arial", 18)
    
    TheMessage.s = "Let out the cat!!!"
    TextGadget(0, 0, 0, 200, 28, TheMessage)
    SetGadgetFont(0, GetStockObject_(#SYSTEM_FONT));FontID(0))
    SetGadgetColor(0, #PB_Gadget_FrontColor, RGB(0,255,0))
    SetGadgetColor(0, #PB_Gadget_BackColor, wcolor);#Magenta)
    
    
; *NewExStyle = #WS_EX_TOOLWINDOW; Toolbar ExStyle
; SetWindowLong_(WindowID(1), #GWL_EXSTYLE, *NewExStyle);Set ExStyle   
; SetWindowPos_(WindowID(1), #HWND_TOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_NOSIZE);Always on top
;     ;CreateImage(0,1,1)
    SetTimer_(WindowID(1), 100, 500, 0)
    SetWindowCallback(@WinCallback(),1)
    ;MessageRequester("init","Done!")
    ProcedureReturn 0
  Else
    ProcedureReturn 1
  EndIf
  EndIf
EndProcedure

Procedure  fconfig()
EndProcedure

Procedure  fquit()
EndProcedure

ProcedureDLL.l winampGetGeneralPurposePlugin()
  plugin\version=$10
  plugin\description=?descr
  plugin\init= @finit()
  plugin\config=@fconfig()
  plugin\quit=@fquit()
  plugin\hwndParent=0
  plugin\hDllInstance=0
  ProcedureReturn @plugin
EndProcedure


DataSection
  descr:
  Data.s "Now Playing by g0blinish"
; IDE Options = PureBasic 5.30 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 83
; FirstLine = 69
; Folding = -
; EnableXP
; Executable = gen_np.dll